Attribute VB_Name = "mod80211"
'Option Explicit
Const maxstrength = -35 'should be -45 === because wireless signal strength
'in db equates to -45 excellent and -95 extremely poor signal
'TO: DO need to write error handling for if progress bar reaches value of 100

Private Sub GetCIMV2(CIMV2Array, CIMV2Query)
   Set CIMV2Class = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2")
   Set CIMV2Array = CIMV2Class.ExecQuery(CIMV2Query)
End Sub

Private Sub GetWMI(WMIArray, WMIQuery)
   Set WMIClass = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\wmi")
   Set WMIArray = WMIClass.ExecQuery(WMIQuery)
End Sub

Public Function SigStrength()
   Call GetWMI(objMSNdis_80211_ReceivedSignalStrengthSet, "Select * from MSNdis_80211_ReceivedSignalStrength Where active=true")
   For Each objMSNdis_80211_ReceivedSignalStrength In objMSNdis_80211_ReceivedSignalStrengthSet
       SigStrength = objMSNdis_80211_ReceivedSignalStrength.Ndis80211ReceivedSignalStrength & " db"
   Next
End Function

Public Function SigStrengthBar()
   Call GetWMI(objMSNdis_80211_ReceivedSignalStrengthSet, "Select * from MSNdis_80211_ReceivedSignalStrength Where active=true")

   For Each objMSNdis_80211_ReceivedSignalStrength In objMSNdis_80211_ReceivedSignalStrengthSet
       SigStrengthBarRaw = objMSNdis_80211_ReceivedSignalStrength.Ndis80211ReceivedSignalStrength
   Next
   SigStrengthBar = 0
   If SigStrengthBarRaw > -57 Then
    SigStrengthBar = "Excellent"
   ElseIf SigStrengthBarRaw > -68 Then
    SigStrengthBar = "Very Good"
   ElseIf SigStrengthBarRaw > -72 Then
    SigStrengthBar = "Good"
   ElseIf SigStrengthBarRaw > -80 Then
    SigStrengthBar = "Low"
   ElseIf SigStrengthBarRaw > -90 Then
    SigStrengthBar = "Very Low"
   End If

End Function

Public Function SigStrengthPercent()
   Call GetWMI(objMSNdis_80211_ReceivedSignalStrengthSet, "Select * from MSNdis_80211_ReceivedSignalStrength Where active=true")

   For Each objMSNdis_80211_ReceivedSignalStrength In objMSNdis_80211_ReceivedSignalStrengthSet
       SigStrengthPercentRaw = objMSNdis_80211_ReceivedSignalStrength.Ndis80211ReceivedSignalStrength
   Next

SigStrengthPercent = Round((SigStrengthPercentRaw + 100) * (100 / (maxstrength + 100)), 0)

End Function

Public Function SSID()
   Call GetWMI(objMSNdis_80211_ServiceSetIdentifierSet, "Select * from MSNdis_80211_ServiceSetIdentifier Where active=true")

   For Each objMSNdis_80211_ServiceSetIdentifier In objMSNdis_80211_ServiceSetIdentifierSet
       ID = ""
       For i = 0 To objMSNdis_80211_ServiceSetIdentifier.Ndis80211SsId(0)
         ID = ID & Chr(objMSNdis_80211_ServiceSetIdentifier.Ndis80211SsId(i + 4))
       Next
       SSID = ID
   Next
End Function

Public Function MAC()
   Call GetWMI(objMSNdis_80211_BaseServiceSetIdentifier, "Select * from MSNdis_80211_BaseServiceSetIdentifier Where active=true")
   For Each objMSNdis_80211_BaseServiceSetIdentifier In objMSNdis_80211_BaseServiceSetIdentifier
       MAC = Hex(objMSNdis_80211_BaseServiceSetIdentifier.Ndis80211MacAddress(0)) _
       & "-" & Hex(objMSNdis_80211_BaseServiceSetIdentifier.Ndis80211MacAddress(1)) _
       & "-" & Hex(objMSNdis_80211_BaseServiceSetIdentifier.Ndis80211MacAddress(2)) _
       & "-" & Hex(objMSNdis_80211_BaseServiceSetIdentifier.Ndis80211MacAddress(3)) _
       & "-" & Hex(objMSNdis_80211_BaseServiceSetIdentifier.Ndis80211MacAddress(4)) _
       & "-" & Hex(objMSNdis_80211_BaseServiceSetIdentifier.Ndis80211MacAddress(5))
   Next
End Function

Public Function Channel()
    Call GetWMI(objMSNdis_80211_Configuration, "SELECT * FROM MSNdis_80211_Configuration WHERE Active = True")
    Dim channels
        channels = Array(2412000, 2417000, 2422000, 2427000, 2432000, 2437000, 2442000, 2447000, 2452000, 2457000, 2462000)
    For Each objMSNdis_80211_Configuration In objMSNdis_80211_Configuration
        raw_channel = objMSNdis_80211_Configuration.Ndis80211Config.DSConfig
        For i = 0 To UBound(channels)
            If raw_channel = channels(i) Then
                Channel = i + 1
            End If
        Next
    Next
End Function

Public Function Frequency()
    Call GetWMI(objMSNdis_80211_Configuration, "SELECT * FROM MSNdis_80211_Configuration WHERE Active = True")
    For Each objMSNdis_80211_Configuration In objMSNdis_80211_Configuration
        Frequency = (objMSNdis_80211_Configuration.Ndis80211Config.DSConfig / 1000000) & " GHz"
    Next
End Function

Public Function ConnectionStatus()
Dim strName As String
   Call GetWMI(objMSNdis_80211_Configuration, "Select * from MSNdis_80211_Configuration Where active=true")
    For Each objMSNdis_80211_Configuration In objMSNdis_80211_Configuration
    strName = objMSNdis_80211_Configuration.InstanceName

    Call GetCIMV2(objWin32_NetworkAdapter, "Select * from Win32_NetworkAdapter Where Name = '" & strName & "'")


    For Each objWin32_NetworkAdapter In objWin32_NetworkAdapter
        Select Case objWin32_NetworkAdapter.NetConnectionStatus
            Case 0
                ConnectionStatus = "Disconnected"
            Case 1
                ConnectionStatus = "Connecting"
            Case 2
                ConnectionStatus = "Connected"
            Case 3
                ConnectionStatus = "Disconnecting"
            Case 4
                ConnectionStatus = "Hardware not present"
            Case 5
                ConnectionStatus = "Hardware disabled"
            Case 6
                ConnectionStatus = "Hardware malfunction"
            Case 7
                ConnectionStatus = "Media disconnected"
            Case 8
                ConnectionStatus = "Authenticating"
            Case 9
                ConnectionStatus = "Authentication succeeded"
            Case 10
                ConnectionStatus = "Authentication failed"
            Case 11
                ConnectionStatus = "Invalid address"
            Case 12
                ConnectionStatus = "Credentials required"
        End Select
    Next
Next
End Function

Public Function AdapterName()
   Call GetWMI(objMSNdis_EnumerateAdapter, "Select * from MSNdis_EnumerateAdapter Where active=true")
   For Each objMSNdis_EnumerateAdapter In objMSNdis_EnumerateAdapter
        If InStr(1, LCase$(objMSNdis_EnumerateAdapter.InstanceName), LCase$("- packet scheduler miniport")) Then
            AdapterName = Left(objMSNdis_EnumerateAdapter.InstanceName, Len(objMSNdis_EnumerateAdapter.InstanceName) - 27)
        End If
   Next
End Function

Public Function LinkSpeed()
   Call GetWMI(objMSNdis_LinkSpeed, "Select * from MSNdis_LinkSpeed Where active=true")
   For Each objMSNdis_LinkSpeed In objMSNdis_LinkSpeed
       LinkSpeed = (objMSNdis_LinkSpeed.NdisLinkSpeed / 10000) & " Mbps"
   Next
End Function

Public Function NetworkMedium()
   Call GetWMI(objMSNdis_PhysicalMediumType, "Select * from MSNdis_PhysicalMediumType Where active=true")
   For Each objMSNdis_PhysicalMediumType In objMSNdis_PhysicalMediumType
            NetworkMedium = objMSNdis_PhysicalMediumType.NdisPhysicalMediumType
   Next
End Function

Public Function CheckMac(strMac As String) As String
Dim intDashPos As Integer
Dim blnDpos As Boolean
Dim arrMAC() As String

Dim strMac1 As String
Dim strMac2 As String
Dim strMac3 As String
Dim strMac4 As String
Dim strMac5 As String
Dim strMac6 As String

        For intDashPos = 1 To Len(strMac)
            If Mid$(strMac, intDashPos, 1) = "-" Then
                blnDpos = (Not blnDpos)
            ElseIf Mid$(strMac, intDashPos, 1) = "-" Then
                If blnDpos Then Mid$(strMac, intDashPos, 1) = Chr$(0)
            End If
        Next intDashPos
    
        arrMAC = Split(strMac, "-")
            For intDashPos = LBound(arrMAC) To UBound(arrMAC)
                arrMAC(intDashPos) = Replace$(arrMAC(intDashPos), Chr$(0), "-")
                Debug.Print arrMAC(intDashPos)
            Next intDashPos
    strMac1 = arrMAC(0)
    strMac2 = arrMAC(1)
    strMac3 = arrMAC(2)
    strMac4 = arrMAC(3)
    strMac5 = arrMAC(4)
    strMac6 = arrMAC(5)
'The following code corrects the MAC address
    If Len(strMac1) <> 2 Then strMac1 = "0" & strMac1
    If Len(strMac2) <> 2 Then strMac2 = "0" & strMac2
    If Len(strMac3) <> 2 Then strMac3 = "0" & strMac3
    If Len(strMac4) <> 2 Then strMac4 = "0" & strMac4
    If Len(strMac5) <> 2 Then strMac5 = "0" & strMac5
    If Len(strMac6) <> 2 Then strMac6 = "0" & strMac6
'Rebuild MAC into string
CheckMac = strMac1 & "-" & strMac2 & "-" & strMac3 & "-" & strMac4 & "-" & strMac5 & "-" & strMac6
End Function
